import java.util.Random;
import java.util.Scanner;

public class AI {
        
    private Game myGame;
    public static final int AMOUNT_OF_STEPS = 6;

    public AI(Game newGame) {
        myGame = newGame;
    }

    public AI() {
        myGame = new Game();
    }

    public Game getGame() {
        return myGame;
    }

    public void doMove(int column) {
        myGame.doMove(column);
    }

    public int nextMove() {
        Tree tree = new Tree(AMOUNT_OF_STEPS, Game.cloneField(myGame.getField()), myGame.getTurn(), null);

        if (myGame.getTurn() == Player.PLAYER1){
            // columnnumber with highest value.
            // initialized with a randomnumber because all branches could have a value of Integer.MIN_VALUE.
            int highestBranche = getRandomMove();
            int highestValue = Integer.MIN_VALUE;
            
            // Counts the cycles in the loop, holds the columnnumber.
            int counter = 1;
            for (Tree branche : tree.getAllBranches()){
                if ((branche != null) && (branche.getValue() > highestValue)){
                    highestValue = branche.getValue();
                    highestBranche = counter;
                }
                counter++;
            }
            return highestBranche;
        }
        else{ // if (turn == PLAYER2)
            
            // columnnumber with lowest value.
            // initialized with a randomnumber because all branches could have a value of Integer.MIN_VALUE.
            int lowestBranche = getRandomMove();
            int lowestValue = Integer.MAX_VALUE;
            
            // Counts the cycles in the loop, holds the columnnumber.
            int counter = 1;
            for (Tree branche : tree.getAllBranches()){
                if ((branche != null) && (branche.getValue() < lowestValue)){
                    lowestValue = branche.getValue();
                    lowestBranche = counter;
                }
                counter++;
            }
            return lowestBranche;
        }
    }

    private int getRandomMove() {
        while (true) {
            int rdm = (new Random().nextInt(6) + 1);
            if (Game.checkMove(rdm, myGame.getField()))
                return rdm;
        }
    }

    public static void main(String args[]) {
        AI ai = new AI();

        Scanner scn = new Scanner(System.in);
        while (Game.checkWin(ai.getGame().getField()).equals(Player.NOTHING)) {
            System.out.println("Geef de volgende zet");
            int volgendeZet = scn.nextInt();
            ai.doMove(volgendeZet);
            System.out.println("Je zette: " + volgendeZet);
            volgendeZet = ai.nextMove();
            ai.doMove(volgendeZet);
            System.out.println("De computer zette: " + volgendeZet);
        }
        System.out.println(Game.checkWin(ai.getGame().getField()) + "WINT !");

    }

}
